/*
 * common.h - header file for common.c
 *
 * Author: John DiMarco, University of Toronto, CDF
 *         jdd@cdf.toronto.edu
 *
 * $Id: common.h,v 1.3 2000/01/25 13:58:53 jdd Exp $
 */

/* note: assumes kernel pointer is kd */

#include <kvm.h>

extern kvm_t *kd;

#define kvm(a,b) kvm_read(kd,(u_long)a,(char *)&b,sizeof(b))

#define SUNDISK "sd"
#define SSADISK "ssd"
#define SUNTAPE "st"
#define SUNSST "sst"

/* SCSI width definitions */
#define NARROW 8
#define WIDE 16

/* Exported Procedures */

extern char *kvmstr();
void boot_synch_message();
void do_scsi_probe();
char *compute_devicename();
