
/************************************************************************/
/*																		*/
/* ispmail.h: ptisp mailbox definitions									*/
/*																		*/
/* Copyright (c) 1993 by Sun Microsystems, Inc.							*/
/*																		*/
/* From: ispmail.h	1.9	93/08/24 SMI									*/
/*																		*/
/************************************************************************/

static char sccsid_ispmail_h[] = "@(#) ispmail.h 96/12/11 14.1.2.1	96/12/12	Copyright 1993,94 Performance Technologies, Inc.";

/*
 * Mailbox Register 0 status bit definitions.
 */

#define	ISP_MBOX_EVENT_MASK				0xF000
#define	ISP_MBOX_EVENT_ASYNCH			0x8000
#define	ISP_MBOX_EVENT_CMD				0x4000

#define	ISP_MBOX_STATUS_MASK			0x00FF
#define	ISP_MBOX_STATUS_OK				0x00
#define	ISP_MBOX_STATUS_INVALID_CMD		0x01
#define	ISP_MBOX_STATUS_INVALID_PARAMS	0x02
#define	ISP_MBOX_STATUS_BOOT_ERR		0x03
#define	ISP_MBOX_STATUS_FIRMWARE_ERR	0x04

#define	ISP_MBOX_ASYNC_RESET			0x01
#define	ISP_MBOX_ASYNC_ERR				0x02
#define	ISP_MBOX_ASYNC_REQ_DMA_ERR		0x03
#define	ISP_MBOX_ASYNC_RESP_DMA_ERR		0x04
#define	ISP_MBOX_ASYNC_WAKEUP			0x05
#define	ISP_MBOX_ASYNC_INT_RESET		0x06
#define	ISP_MBOX_ASYNC_INT_DEV_RESET	0x07
#define	ISP_MBOX_ASYNC_INT_ABORT		0x08

#define	ISP_MBOX_BUSY					0x04

#define	ISP_MBOX_EVENT_SBUS				0x01
#define	ISP_MBOX_EVENT_REQUEST			0x02

#define	ISP_GET_MBOX_STATUS(mailbox)	(mailbox & ISP_MBOX_STATUS_MASK)
#define	ISP_GET_MBOX_EVENT(mailbox)		(mailbox & ISP_MBOX_STATUS_MASK)

/* asynch event related defines */
#define	ISP_AEN_RESET					-1
#define	ISP_AEN_SUCCESS					1
#define	ISP_AEN_FAILURE					0

#define	ISP_MBOX_CMD_NOP				0x00
#define	ISP_MBOX_CMD_ABOUT_PROM			0x08
#define	ISP_MBOX_CMD_CHECKSUM_FIRMWARE	0x0E
#define	ISP_MBOX_CMD_STOP_FW			0x14
#define	ISP_MBOX_CMD_LOAD_RAM			0x01
#define	ISP_MBOX_CMD_START_FW			0x02
#define	ISP_MBOX_CMD_DUMP_RAM			0x03
#define	ISP_MBOX_CMD_LOAD_WORD			0x04
#define	ISP_MBOX_CMD_DUMP_WORD			0x05
#define	ISP_MBOX_CMD_WRAP_MAILBOXES		0x06
#define	ISP_MBOX_CMD_CHECKSUM			0x07
#define	ISP_MBOX_CMD_INIT_RQST_QUEUE	0x10
#define	ISP_MBOX_CMD_INIT_RSPN_QUEUE	0x11
#define	ISP_MBOX_CMD_SCSI_CMD			0x12
#define	ISP_MBOX_CMD_WAKE_UP			0x13
#define	ISP_MBOX_CMD_ABORT_IOCB			0x15
#define	ISP_MBOX_CMD_ABORT_DEVICE		0x16
#define	ISP_MBOX_CMD_ABORT_TARGET		0x17
#define	ISP_MBOX_CMD_BUS_RESET			0x18
#define	ISP_MBOX_CMD_STOP_QUEUE			0x19
#define	ISP_MBOX_CMD_START_QUEUE		0x1A
#define	ISP_MBOX_CMD_STEP_QUEUE			0x1B
#define	ISP_MBOX_CMD_ABORT_QUEUE		0x1C
#define	ISP_MBOX_CMD_GET_DEV_Q_STATE	0x1D
#define	ISP_MBOX_CMD_GET_FW_STATUS		0x1F
#define	ISP_MBOX_CMD_GET_SXP_CONFIG		0x2F
#define	ISP_MBOX_CMD_SET_SXP_CONFIG		0x3F
#define	ISP_MBOX_CMD_GET_SCSI_ID		0x20
#define	ISP_MBOX_CMD_SET_SCSI_ID		0x30
#define	ISP_MBOX_CMD_GET_SEL_TIMEOUT	0x21
#define	ISP_MBOX_CMD_SET_SEL_TIMEOUT	0x31
#define	ISP_MBOX_CMD_GET_RETRY_ATTEMPTS	0x22
#define	ISP_MBOX_CMD_SET_RETRY_ATTEMPTS	0x32
#define	ISP_MBOX_CMD_GET_AGE_LIMIT		0x23
#define	ISP_MBOX_CMD_SET_AGE_LIMIT		0x33
#define	ISP_MBOX_CMD_GET_CLOCK_RATE		0x24
#define	ISP_MBOX_CMD_SET_CLOCK_RATE		0x34
#define	ISP_MBOX_CMD_GET_PULL_UPS		0x25
#define	ISP_MBOX_CMD_SET_PULL_UPS		0x35
#define	ISP_MBOX_CMD_GET_DAT_TRANS_TIME	0x26
#define	ISP_MBOX_CMD_SET_DAT_TRANS_TIME	0x36
#define	ISP_MBOX_CMD_GET_SBUS_INTERFACE	0x27
#define	ISP_MBOX_CMD_SET_SBUS_INTERFACE	0x37
#define	ISP_MBOX_SBUS_ENA_DMA_BURST		0x02
#define	ISP_MBOX_CMD_GET_TARGET_CAP		0x28
#define	ISP_MBOX_CMD_SET_TARGET_CAP		0x38
#define	ISP_MBOX_CMD_GET_DEV_Q_PARAMS	0x29
#define	ISP_MBOX_CMD_SET_DEV_Q_PARAMS	0x39

#define	ISP_CAP_DISCONNECT				0x8000
#define	ISP_CAP_PARITY					0x4000
#define	ISP_CAP_WIDE					0x2000
#define	ISP_CAP_SYNC					0x1000
#define	ISP_CAP_TAG						0x0800
#define	ISP_CAP_AUTOSENSE				0x0400
#define	ISP_CAP_ERRSTOP					0x0200
#define	ISP_CAP_ERRSYNC					0x0100
#define	ISP_CAP_10M_SYNC_PERIOD			0x0019
#define	ISP_CAP_10M_SYNC_OFFSET			0x000C
#define	ISP_CAP_10M_SYNC_PARAMS			0x0C19	/* (OFFSET<<8) | PERIOD	*/
#define	ISP_CAP_8M_SYNC_PERIOD			0x0025
#define	ISP_CAP_8M_SYNC_OFFSET			0x000C
#define	ISP_CAP_8M_SYNC_PARAMS			0x0C25	/* (OFFSET<<8) | PERIOD	*/
#define	ISP_CAP_5M_SYNC_PERIOD			0x0032
#define	ISP_CAP_5M_SYNC_OFFSET			0x000C
#define	ISP_CAP_5M_SYNC_PARAMS			0x0C32	/* (OFFSET<<8) | PERIOD	*/
#define	ISP_CAP_4M_SYNC_PERIOD			0x0041
#define	ISP_CAP_4M_SYNC_OFFSET			0x000C
#define	ISP_CAP_4M_SYNC_PARAMS			0x0C41	/* (OFFSET<<8) | PERIOD	*/

#define ISP_CAP_GET_PERIOD(param)		(param & 0xFF)
#define	ISP_CAP_SET_SYNC_PERIOD(oval,sval)	( (oval)<<8 | (sval))
#define ISP_CAP_PERIOD_CLICK			6

/* mailbox related structures and defines */
#define	ISP_MAX_MBOX_REGS				6
#define	ISP_MBOX_CMD_TIMEOUT			10
#define	ISP_MBOX_CMD_RETRY_CNT			1
#define	ISP_MBOX_CMD_FLAGS_COMPLETE		0x01

/*
 * mailbox command struct
 *
 * sizeof(ptisp_mbox_cmd) = 4 + 6 * 2 + 6 * 2 + 4 = 32 bytes.
 */

struct ptisp_mbox_cmd {
	u_int		timeout;				/* timeout for cmd				*/
	u_short		out[ISP_MAX_MBOX_REGS];	/* outgoing registers			*/
	u_short		in[ISP_MAX_MBOX_REGS];	/* incoming registers			*/
	u_char		retry_cnt;				/* retry count					*/
	u_char		n_out;					/* no of mbox out regs wrt drv	*/
	u_char		n_in;					/* no of mbox in  regs wrt drv	*/
	u_char		not_used;
};

/*
 * ptisp mailbox struct
 */

struct ptisp_mbox {
	u_char		flags; 					/* mbox register flags			*/
	struct ptisp_mbox_cmd cmd;			/* mbox command					*/
};

#define	ISP_MBOX_CMD_BUSY_WAIT_TIME		1    /* sec						*/
#define	ISP_MBOX_CMD_BUSY_POLL_DELAY	100  /* usecs					*/

/*........................... End of ispmail.h .........................*/
