/*
 * uscsi.h - header file for uscsi.c
 *
 * Author: John DiMarco, University of Toronto, CDF
 *         jdd@cdf.toronto.edu
 * 
 * $Id: uscsi.h,v 3.4 1998/08/07 20:55:50 jdd Exp $
 */

/* Exported Procedures */

extern int scsi_read_blklim();
extern int scsi_probe();
extern int scsi_inquiry();
extern int scsi_modeinfo();
extern int scsi_capacity();
extern char *scsi_dtype();

#define INQ_WBUS32	0x02
#define INQ_WBUS16	0x04

#define INQ_RELADR	0x01
#define INQ_TXT_RELADR	"REL_ADDR"

#define INQ_SYNC	0x08
#define INQ_TXT_SYNC	"SYNC_SCSI"

#define INQ_LINKED	0x10
#define INQ_TXT_LINKED	"LINK_CMD"

#define INQ_RSRVED	0x20
#define INQ_TXT_RSRVED	"RESERVED"

#define INQ_CMDQUE	0x40
#define INQ_TXT_CMDQUE	"TAG_QUEUE"

#define INQ_SFTRE	0x80
#define INQ_TXT_SFTRE	"SOFT_RESET"

/* size of various fields in INQUIRY data */

#define VENDOR_SIZE 	8
#define PRODUCT_SIZE 	16
#define REVISION_SIZE 	4
#define SERIAL_SIZE 	20
